var oFormScope;

/**
 * constructor_form
 * Fonction appelé à l'initialisation du formulaire
 * @param {type} scope
 */
constructor_form = function (scope) {
    console.log("constructor_form");

    oFormScope = scope;
};


/**
 * Créer des evements pour detecter les changements dans les listes et recharger les valeurs des listes dépendante
 */
angular.element(vitisApp.appMainDrtv).scope()["initBoForm"] = function () {
    var scope = this;

    if (!angular.isDefined(oFormScope['oFormValues'][oFormScope['sFormDefinitionName']]['geom_column'])) {
        oFormScope['oFormValues'][oFormScope['sFormDefinitionName']]['geom_column'] = '';
    }
}

/**
 * Rafraichissement des selects
 */
angular.element(vitisApp.appMainDrtv).scope()["refreshSelects"] = function () {
    var scope = this;

    scope.loadVMapBoFormColumns();
    scope.loadVMapBoFormSummaryColumns();
}

/**
 * Vérifie la validité de la base de données selectionnée
 */
angular.element(vitisApp.appMainDrtv).scope()["checkSelectedDatabase"] = function () {
    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sDatabase = oFormValues['database'];
    if (angular.isDefined(sDatabase['selectedOption'])) {
        if (angular.isDefined(sDatabase['selectedOption']['value'])) {
            sDatabase = sDatabase['selectedOption']['value'];
        }
    }
    if (!angular.isString(sDatabase)) {
        $.notify('Base de données incorrecte');
        return;
    } else if (!sDatabase.length > 0) {
        $.notify('Base de données incorrecte');
        return;
    }

    return sDatabase;
}

/**
 * Vérifie la validité du schema selectionné
 */
angular.element(vitisApp.appMainDrtv).scope()["checkSelectedSchema"] = function () {
    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sSchema = oFormValues['schema'];
    if (angular.isDefined(sSchema['selectedOption'])) {
        if (angular.isDefined(sSchema['selectedOption']['value'])) {
            sSchema = sSchema['selectedOption']['value'];
        }
    }
    if (!angular.isString(sSchema)) {
        $.notify('Nom du schema incorrect');
        return;
    } else if (!sSchema.length > 0) {
        $.notify('Nom du schema incorrect');
        return;
    }

    return sSchema;
}

/**
 * Vérifie la validité de la table selectionnée
 */
angular.element(vitisApp.appMainDrtv).scope()["checkSelectedTable"] = function () {
    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sTable = oFormValues['table'];
    if (angular.isDefined(sTable['selectedOption'])) {
        if (angular.isDefined(sTable['selectedOption']['value'])) {
            sTable = sTable['selectedOption']['value'];
        }
    }
    if (!angular.isString(sTable)) {
        $.notify('Table incorrecte');
        return;
    } else if (!sTable.length > 0) {
        $.notify('Table incorrecte');
        return;
    }

    return sTable;
}

/**
 * Charge la liste des schemas
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormSchemas"] = function(){
    console.log('loadVMapBoFormSchemas');

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];

    var sDatabase = this.checkSelectedDatabase();

    if (!angular.isDefined(sDatabase)) {
        return
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys/' + sDatabase + '/schemas',
        'params': {
            'distinct':true,
            'order_by':'schema_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aSchemasOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aSchemasOptions.push({
                            'label': response['data']['genericquerys'][i]['schema_name'],
                            'value': response['data']['genericquerys'][i]['schema_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['schema'])) {
                    if (angular.isDefined(oFormValues['schema']['options'])) {
                        oFormValues['schema']['options'] = aSchemasOptions;
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};

/**
 * Charge la liste des tables
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormTables"] = function(){
    console.log('loadVMapBoFormTables');

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];

    var sDatabase = this.checkSelectedDatabase();

    if (!angular.isDefined(sDatabase)) {
        return
    }

    var sSchema = this.checkSelectedSchema();

    if (!angular.isDefined(sSchema)) {
        return
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys',
        'params': {
            'database':sDatabase,
            'schema':sSchema,
            'distinct':true,
            'order_by':'table_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aTablesOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aTablesOptions.push({
                            'label': response['data']['genericquerys'][i]['table_name'],
                            'value': response['data']['genericquerys'][i]['table_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['table'])) {
                    if (angular.isDefined(oFormValues['table']['options'])) {
                        oFormValues['table']['options'] = aTablesOptions;
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};

/**
 * Charge la liste des colonnes
 */
 angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormColumns"] = function(){
    console.log('loadVMapBoFormColumns');

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];

    var sDatabase = this.checkSelectedDatabase();

    if (!angular.isDefined(sDatabase)) {
        return;
    }

    var sSchema = this.checkSelectedSchema();

    if (!angular.isDefined(sSchema)) {
        return;
    }

    var sTable = this.checkSelectedTable();

    if (!angular.isDefined(sTable)) {
        return;
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' +  oFormScope['oProperties']['services_alias'] + '/vitis/genericquerys/workspace/columns',
        'params': {
            'database':sDatabase,
            'schema':sSchema,
            'table':sTable,
            'distinct':true,
            'order_by':'column_name',
            'sort_order':'ASC'
        },
        'scope': oFormScope,
        'success': function (response) {

            var aColumnsOptions = [];
            if (angular.isDefined(response['data'])) {
                if (angular.isArray(response['data']['genericquerys'])) {
                    for (var i = 0; i < response['data']['genericquerys'].length; i++) {
                        aColumnsOptions.push({
                            'label': response['data']['genericquerys'][i]['column_name'],
                            'value': response['data']['genericquerys'][i]['column_name']
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function(){
                if (angular.isDefined(oFormValues['id_field'])) {
                    if (oFormValues['id_field'] == null) {
                        oFormValues['id_field'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['id_field']['options'])) {
                        oFormValues['id_field']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['sorted_by'])) {
                    if (oFormValues['sorted_by'] == null) {
                        oFormValues['sorted_by'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['sorted_by']['options'])) {
                        oFormValues['sorted_by']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['geom_column'])) {
                    if (oFormValues['geom_column'] == null) {
                        oFormValues['geom_column'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['geom_column']['options'])) {
                        oFormValues['geom_column']['options'] = aColumnsOptions;
                    }
                    if (!angular.isDefined(oFormValues['geom_column']['selectedOption'])) {
                        oFormValues['geom_column']['selectedOption'] = {
                            'value': ''
                        }
                    }
                }
                if (angular.isDefined(oFormValues['search_field'])) {
                    if (oFormValues['search_field'] == null) {
                        oFormValues['search_field'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['search_field']['options'])) {
                        oFormValues['search_field']['options'] = aColumnsOptions;
                    }
                }
                // Mise à jour en insert seulement pour result_field et multipopup_field
                if (oFormScope['sFormDefinitionName'] === 'vmap_business_object_vmap_business_object_general_insert_form') {
                    if (angular.isDefined(oFormValues['result_field'])) {
                        if (oFormValues['result_field'] == null) {
                            oFormValues['result_field'] = {
                                'options': []
                            };
                        }
                        if (angular.isDefined(oFormValues['result_field']['options'])) {
                            oFormValues['result_field']['options'] = aColumnsOptions;
                        }
                    }
                    if (angular.isDefined(oFormValues['multipopup_field'])) {
                        if (oFormValues['multipopup_field'] == null) {
                            oFormValues['multipopup_field'] = {
                                'options': []
                            };
                        }
                        if (angular.isDefined(oFormValues['multipopup_field']['options'])) {
                            oFormValues['multipopup_field']['options'] = aColumnsOptions;
                        }
                    }
                }
            });

        },
        'error': function (error){
            console.error('error', error);
        }
    });
};

/**
 * Charge la liste des colonnes en fonction du sql summary
 */
angular.element(vitisApp.appMainDrtv).scope()["loadVMapBoFormSummaryColumns"] = function () {
    console.log('loadVMapBoFormSummaryColumns');

    if (!angular.isDefined(oFormScope['oFormValues'])) {
        return;
    }

    var oFormValues = oFormScope['oFormValues'][oFormScope['sFormDefinitionName']];
    if (!angular.isDefined(oFormValues)) {
        return;
    }

    var sDatabase = this.checkSelectedDatabase();

    if (!angular.isDefined(sDatabase)) {
        return;
    }

    var sSchema = this.checkSelectedSchema();

    if (!angular.isDefined(sSchema)) {
        return;
    }

    var sTable = this.checkSelectedTable();

    if (!angular.isDefined(sTable)) {
        return;
    }

    ajaxRequest({
        'method': 'GET',
        'url': oFormScope['oProperties']['web_server_name'] + '/' + oFormScope['oProperties']['services_alias'] + '/vmap/querys/' + oFormValues['business_object_id'] + '/summary',
        'params': {
            'limit': 1
        },
        'scope': oFormScope,
        'success': function (response) {

            var aColumnsOptions = [];
            if (angular.isDefined(response['data']) 
                && angular.isDefined(response['data']['querys'])
                && angular.isDefined(response['data']['querys'][0]['bo_summary_attributs'])) {
                if (angular.isArray(response['data']['querys'][0]['bo_summary_attributs'])) {
                    for (var i = 0; i < response['data']['querys'][0]['bo_summary_attributs'].length; i++) {
                        aColumnsOptions.push({
                            'label': response['data']['querys'][0]['bo_summary_attributs'][i],
                            'value': response['data']['querys'][0]['bo_summary_attributs'][i]
                        });
                    }
                }
            }

            oFormScope.$applyAsync(function () {
                if (angular.isDefined(oFormValues['result_field'])) {
                    if (oFormValues['result_field'] == null) {
                        oFormValues['result_field'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['result_field']['options'])) {
                        oFormValues['result_field']['options'] = aColumnsOptions;
                    }
                }
                if (angular.isDefined(oFormValues['multipopup_field'])) {
                    if (oFormValues['multipopup_field'] == null) {
                        oFormValues['multipopup_field'] = {
                            'options': []
                        };
                    }
                    if (angular.isDefined(oFormValues['multipopup_field']['options'])) {
                        oFormValues['multipopup_field']['options'] = aColumnsOptions;
                    }
                }
            });

        },
        'error': function (error) {
            console.error('error', error);
        }
    });
};